//========================================================================================
//
//	File:				Select.cpp
//	Release Version:	$ ODF 1 $
//
//	Copyright:			(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#include "Form.hpp"

#ifndef SELECT_H
#include "Select.h"
#endif

#ifndef CONTENT_H
#include "Content.h"
#endif

#ifndef PART_H
#include "Part.h"
#endif

#ifndef DEFINES_K
#include "Defines.k"
#endif

// ----- Framework Includes -----

#ifndef FWPRESEN_H
#include "FWPresen.h"
#endif

#ifndef FWUTIL_H
#include "FWUtil.h"
#endif

// ----- OS Includes -----

#ifndef FWBARRAY_H
#include "FWBArray.h"
#endif

// ----- Foundation Layer -----

#ifndef FWSUSINK_H
#include "FWSUSink.h"
#endif

#ifndef FWSTREAM_H
#include "FWStream.h"
#endif

#ifndef FWSTRING_H
#include "FWString.h"
#endif

// ----- OpenDoc Includes -----

#ifndef SOM_Module_OpenDoc_StdProps_defined
#include <StdProps.xh>
#endif

// ----- Macintosh Includes -----

#if defined(FW_BUILD_MAC) && !defined(__DRAG__)
#include <Drag.h>
#endif

//========================================================================================
//	Runtime information
//========================================================================================

#ifdef FW_BUILD_MAC
#pragma segment Form
#endif

FW_DEFINE_AUTO(CFormSelection)

//========================================================================================
//	Constants
//========================================================================================

const ODPropertyName kFormPropText = "Form:Property:Text";

//========================================================================================
//	CLASS CFormSelection
//========================================================================================

//---------------------------------------------------------------------------------------
//	CFormSelection constructor
//---------------------------------------------------------------------------------------

CFormSelection::CFormSelection(Environment* ev, CFormContent* content) :
	FW_CSelection(ev, false, false),
	fFormContent(content)
{
}

//---------------------------------------------------------------------------------------
//	CFormSelection destructor
//---------------------------------------------------------------------------------------

CFormSelection::~CFormSelection()
{
}

//---------------------------------------------------------------------------------------
//	CFormSelection::GetSelectedContent
//---------------------------------------------------------------------------------------
//	The whole content is always selected

FW_CContent* CFormSelection::GetSelectedContent(Environment* ev)
{
	return fFormContent;
}

//---------------------------------------------------------------------------------------
//	CFormSelection::ClearSelection
//---------------------------------------------------------------------------------------

void CFormSelection::ClearSelection(Environment* ev)
{
	fFormContent->ClearTextData(ev);
}

//---------------------------------------------------------------------------------------
//	CFormSelection::CloseSelection
//---------------------------------------------------------------------------------------

void CFormSelection::CloseSelection(Environment* ev)
{
	// Nothing to do
}

//---------------------------------------------------------------------------------------
//	CFormSelection::IsEmpty
//---------------------------------------------------------------------------------------

FW_Boolean CFormSelection::IsEmpty(Environment* ev) const
{
	// Is the current string empty?
	return (fFormContent->GetTextData().GetByteLength() == 0);
}

//---------------------------------------------------------------------------------------
//	CFormSelection::SelectAll
//---------------------------------------------------------------------------------------

void CFormSelection::SelectAll(Environment* ev)
{
	// Part's data is always "selected"
}
