//========================================================================================
//
//	File:				Select.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef SELECT_H
#define SELECT_H

// ----- Framework Includes -----

#ifndef FWSELECT_H
#include "FWSelect.h"
#endif

//========================================================================================
//	Forward Declarations
//========================================================================================

class FW_CCloneInfo;

class CFormContent;
class FW_CString;

//========================================================================================
//	class CFormSelection
//========================================================================================

class CFormSelection : public FW_CSelection
{
//----------------------------------------------------------------------------------------
//	Initialization/Destruction
//
  public:

	FW_DECLARE_AUTO(CFormSelection)

	CFormSelection(Environment* ev, CFormContent* content);
	virtual ~CFormSelection();

//----------------------------------------------------------------------------------------
//	Inherited API
//
  public:
	virtual void			CloseSelection(Environment* ev);
	virtual void			ClearSelection(Environment* ev);
	virtual FW_Boolean		IsEmpty(Environment* ev) const;
	virtual void			SelectAll(Environment* ev);

	virtual FW_CContent*	GetSelectedContent(Environment* ev);

//----------------------------------------------------------------------------------------
//	Data Members
//
  private:
	CFormContent*		fFormContent;
};


#endif
