// CMainWindow.cp -- window methods
// Created 3/19/96 1:49 PM by AppMaker

#include "CMainWindow.h"

#include <UReanimator.h>
#include <URegistrar.h>
#include <LStream.h>
#include <LListBox.h>
#include <LStdControl.h>
#include "CAMReminderData.h"
#include "CAdd.h"
#include "CmdCodes.h"

#define PPob_MainWindowID	200
#define RidL_MainWindowID	200

Boolean		CMainWindow::sIsRegistered = false;

//----------
void
CMainWindow::RegisterClass ()
{
	URegistrar::RegisterClass ('Main', (ClassCreatorFunc)CMainWindow::CreateMainWindowStream);

	// register the pane classes we use

	sIsRegistered = true;
}

//----------
CMainWindow*
CMainWindow::CreateMainWindow(
	LCommander			*inSuperCommander,
	CAMReminderData		*inData)
{
	if (!sIsRegistered) {
		RegisterClass ();
	}

	CMainWindow		*window;

	window = (CMainWindow *)LWindow::CreateWindow(PPob_MainWindowID, inSuperCommander);
	window->ConnectToData (inData);

	return window;
}

//----------
//	This is the function you register with URegistrar to create a
//	CMainWindow from a resource

CMainWindow*
CMainWindow::CreateMainWindowStream(
	LStream	*inStream)
{
	return (new CMainWindow(inStream));
}

//----------
CMainWindow::CMainWindow()
{
}

//----------
CMainWindow::CMainWindow(
	LStream	*inStream)
		: LWindow(inStream)
{
}

//----------
CMainWindow::~CMainWindow()
{
}

//----------
//	This member function gets called once the containment hierarchy that contains
//	this pane has been built. It gives us a chance to get data members for
//	interesting subviews, and to do other operations now that our subviews exist.
void
CMainWindow::FinishCreateSelf()
{
	mRemindersList = (LListBox *)FindPaneByID('Remi');
	mAddButton = (LStdButton *)FindPaneByID ('Add ');
	mEditButton = (LStdButton *)FindPaneByID ('Edit');
	mDeleteButton = (LStdButton *)FindPaneByID ('Dele');

	UReanimator::LinkListenerToControls(this, this, RidL_MainWindowID);
		// the purpose is to "connect" self to whatever controls
		// that we want to "listen" to

// any additional initialization for your window:

}

//----------
void
CMainWindow::ConnectToData	(CAMReminderData		*inData)
{
	mData = inData;
	inData->AddListener (this);
}

//----------
void
CMainWindow::DoAddReminder ()
{
CAdd*	dialog = CAdd::CreateAdd(this);
}

//----------
void
CMainWindow::DoEditReminder ()
{
CAdd*	dialog = CAdd::CreateAdd(this);
}

//----------
void
CMainWindow::DoDeleteReminder ()
{
}

//----------
void
CMainWindow::ObeyAdd	(void*	ioParam)
{
CAdd*	dialog = (CAdd *)ioParam;

delete dialog;
}

//----------
void
CMainWindow::ListenToMessage(
	MessageT	inMessage,
	void		*ioParam)
{
	switch (inMessage) {

	case cmdAddReminder:
		DoAddReminder ();
		break;

	case cmdEditReminder:
		DoEditReminder ();
		break;

	case cmdDeleteReminder:
		DoDeleteReminder ();
		break;

	default:
		break;
	}
}

//----------
Boolean
CMainWindow::ObeyCommand(
	CommandT	inCommand,
	void		*ioParam)
{
	Boolean		cmdHandled = true;

	switch (inCommand) {

	// +++ Add cases here for the commands you handle
	//		Remember to add same cases to FindCommandStatus below
	//		to enable/disable the commands

	case cmd_Add:
		ObeyAdd	(ioParam);
		break;

	default:
			cmdHandled = LWindow::ObeyCommand(inCommand, ioParam);
		break;
	}

	return cmdHandled;
}

//----------
void
CMainWindow::FindCommandStatus(
	CommandT	inCommand,
	Boolean		&outEnabled,
	Boolean		&outUsesMark,
	Char16		&outMark,
	Str255		outName)
{
	outUsesMark = false;

	switch (inCommand) {

	// +++ Add cases here for the commands you handle
	case cmdAddReminder:
		outEnabled = true;
		break;
	case cmdEditReminder:
		outEnabled = true;
		break;
	case cmdDeleteReminder:
		outEnabled = true;
		break;

	default:
			LWindow::FindCommandStatus(inCommand, outEnabled,
										outUsesMark, outMark, outName);
		break;
	}
}

//----------
Boolean
CMainWindow::FocusDraw()
{
	Boolean		focused = LView::FocusDraw();

	if (focused) {
		AuxWinHandle	awHndl;
		CTabHandle		awCTable;
		ColorSpec		contentSpec;

		GetAuxWin(GetMacPort(), &awHndl);
		awCTable = (**awHndl).awCTable;
		contentSpec = (**awCTable).ctTable [wContentColor];		// should search vs. index
		::RGBBackColor(&contentSpec.rgb);
	}

	return focused;
}
