// CReminderEntry -- data container class for AMReminder
// Created 3/19/96 1:49 PM by AppMaker

#pragma once

#include <PP_Prefix.h>

#include "NeoTypes.h"
#include CNeoPersistH

class CNeoDatabase;
class CNeoMetaClass;

const NeoID		kReminderEntryID = 21;

//----------
class CReminderEntry : public CNeoPersist {
public:
				CReminderEntry ();
				CReminderEntry	(CNeoDatabase	*inFile);
	virtual		~CReminderEntry ();

// accessors
	void		GetDateField	(StringPtr	text) const;
	void		SetDateField	(ConstStr255Param	text);
	void		GetTimeField	(StringPtr	text) const;
	void		SetTimeField	(ConstStr255Param	text);
	void		GetMessageField	(StringPtr	text) const;
	void		SetMessageField	(ConstStr255Param	text);
	long		GetAmPmChoice	() const {return mAmPmChoice;}
	void		SetAmPmChoice	(long		state);
	Boolean		GetShowAlertCheck	() const {return mShowAlertCheck;}
	void		SetShowAlertCheck	(Boolean		state);
	Boolean		GetPlaySoundCheck	() const {return mPlaySoundCheck;}
	void		SetPlaySoundCheck	(Boolean		state);
	Boolean		GetShowIconCheck	() const {return mShowIconCheck;}
	void		SetShowIconCheck	(Boolean		state);
	short		GetSoundIndex	() const {return mSoundIndex;}
	void		SetSoundIndex	(short		state);

// NeoPersist
	static	CNeoMetaClass*		GetMetaClass ();
	static	void				AddMetaClass ();
	static	CNeoPersist*		New ();
	static	CReminderEntry*		FindByID	(CNeoDatabase		*aFile,
										const NeoID			aID,
										const Boolean		aDeeply,
											  NeoTestFunc1	aFunc = nil,
											  void			*aParam = nil,
										const NeoLockType	aLock = kNeoDefaultLock);

	virtual NeoID		getClassID		() const {return kReminderEntryID;}
	virtual long		getFileLength	() const;

// I/O
	virtual void		readObject		(CNeoStream		*aStream,
									const NeoTag		aTag);
	virtual void		writeObject		(CNeoStream		*aStream,
									const NeoTag		aTag);

private:
	Str31		mDateField;
	Str31		mTimeField;
	Str255		mMessageField;
	long		mAmPmChoice;
	Boolean		mShowAlertCheck;
	Boolean		mPlaySoundCheck;
	Boolean		mShowIconCheck;
	short		mSoundIndex;
};
