// CButtons.cp -- window methods
// Created 3/19/96 12:49 PM by AppMaker

#include "CButtons.h"

#include <UReanimator.h>
#include <URegistrar.h>
#include <LStream.h>
#include <CInvisibleButton.h>
#include <LStdControl.h>
#include "CGadgetsData.h"
#include "CmdCodes.h"

#define PPob_ButtonsID	200
#define RidL_ButtonsID	200

Boolean		CButtons::sIsRegistered = false;

//----------
void
CButtons::RegisterClass ()
{
	URegistrar::RegisterClass ('Buts', (ClassCreatorFunc)CButtons::CreateButtonsStream);

	// register the pane classes we use
	CInvisibleButton::RegisterClass ();

	sIsRegistered = true;
}

//----------
CButtons*
CButtons::CreateButtons(
	LCommander			*inSuperCommander,
	CGadgetsData		*inData)
{
	if (!sIsRegistered) {
		RegisterClass ();
	}

	CButtons		*window;

	window = (CButtons *)LWindow::CreateWindow(PPob_ButtonsID, inSuperCommander);
	window->ConnectToData (inData);

	return window;
}

//----------
//	This is the function you register with URegistrar to create a
//	CButtons from a resource

CButtons*
CButtons::CreateButtonsStream(
	LStream	*inStream)
{
	return (new CButtons(inStream));
}

//----------
CButtons::CButtons()
{
}

//----------
CButtons::CButtons(
	LStream	*inStream)
		: LWindow(inStream)
{
}

//----------
CButtons::~CButtons()
{
}

//----------
//	This member function gets called once the containment hierarchy that contains
//	this pane has been built. It gives us a chance to get data members for
//	interesting subviews, and to do other operations now that our subviews exist.
void
CButtons::FinishCreateSelf()
{
	mInvisibleButton = (CInvisibleButton *)FindPaneByID ('Inv2');
	mOKButton = (LStdButton *)FindPaneByID ('OK  ');
	mX3DButton = (LStdButton *)FindPaneByID ('X3D ');
	mPictButtonButton = (LStdButton *)FindPaneByID ('Picn');
	mTitledPictButton = (LStdButton *)FindPaneByID ('Titt');
	mCheckCheck = (LStdCheckBox *)FindPaneByID ('Chek');
	mX3DRadioRadio = (LStdRadioButton *)FindPaneByID ('X3Do');
	mPictCheckCheck = (LStdCheckBox *)FindPaneByID ('Pick');
	mX3DCheckCheck = (LStdCheckBox *)FindPaneByID ('X3Dk');

	UReanimator::LinkListenerToControls(this, this, RidL_ButtonsID);
		// the purpose is to "connect" self to whatever controls
		// that we want to "listen" to

// any additional initialization for your window:

}

//----------
void
CButtons::ConnectToData	(CGadgetsData		*inData)
{
	mData = inData;
	inData->AddListener (this);
}

//----------
void
CButtons::ListenToMessage(
	MessageT	inMessage,
	void		*ioParam)
{
	switch (inMessage) {

	default:
		break;
	}
}

//----------
Boolean
CButtons::ObeyCommand(
	CommandT	inCommand,
	void		*ioParam)
{
	Boolean		cmdHandled = true;

	switch (inCommand) {

	// +++ Add cases here for the commands you handle
	//		Remember to add same cases to FindCommandStatus below
	//		to enable/disable the commands

	default:
			cmdHandled = LWindow::ObeyCommand(inCommand, ioParam);
		break;
	}

	return cmdHandled;
}

//----------
void
CButtons::FindCommandStatus(
	CommandT	inCommand,
	Boolean		&outEnabled,
	Boolean		&outUsesMark,
	Char16		&outMark,
	Str255		outName)
{
	outUsesMark = false;

	switch (inCommand) {

	// +++ Add cases here for the commands you handle

	default:
			LWindow::FindCommandStatus(inCommand, outEnabled,
										outUsesMark, outMark, outName);
		break;
	}
}

//----------
Boolean
CButtons::FocusDraw()
{
	Boolean		focused = LView::FocusDraw();

	if (focused) {
		AuxWinHandle	awHndl;
		CTabHandle		awCTable;
		ColorSpec		contentSpec;

		GetAuxWin(GetMacPort(), &awHndl);
		awCTable = (**awHndl).awCTable;
		contentSpec = (**awCTable).ctTable [wContentColor];		// should search vs. index
		::RGBBackColor(&contentSpec.rgb);
	}

	return focused;
}
