// CButtons.h -- window class
// Created 3/19/96 12:49 PM by AppMaker

#pragma once

#include <LWindow.h>
#include <LListener.h>

class	CGadgetsData;
class	LStream;

class	CInvisibleButton;
class	LStdButton;
class	LStdCheckBox;
class	LStdRadioButton;

//----------
class	CButtons :	public LWindow,
						public LListener {
public:
	static	CButtons*	CreateButtons		(LCommander			*inSuperCommander,
													 CGadgetsData	*inData);

	static	CButtons*	CreateButtonsStream	(LStream	*inStream);

						CButtons();
						CButtons		(LStream	*inStream);
	virtual				~CButtons();

	virtual void		ListenToMessage		(MessageT	inMessage,
											 void		*ioParam);

	virtual Boolean		ObeyCommand			(CommandT	inCommand,
											 void		*ioParam = nil);
	virtual void		FindCommandStatus	(CommandT	inCommand,
											 Boolean	&outEnabled,
											 Boolean	&outUsesMark,
											 Char16		&outMark,
											 Str255		outName);
	virtual Boolean		FocusDraw();

protected:
	static	void		RegisterClass();
	virtual void		FinishCreateSelf();
	virtual void		ConnectToData	(CGadgetsData	*inData);

protected:

protected:
	static Boolean		sIsRegistered;

	CGadgetsData		*mData;

// Panes in this window:
	CInvisibleButton*	mInvisibleButton;
	LStdButton*		mOKButton;
	LStdButton*		mX3DButton;
	LStdButton*		mPictButtonButton;
	LStdButton*		mTitledPictButton;
	LStdCheckBox*		mCheckCheck;
	LStdRadioButton*		mX3DRadioRadio;
	LStdCheckBox*		mPictCheckCheck;
	LStdCheckBox*		mX3DCheckCheck;
};
