// CProgressBars.cp -- window methods
// Created 3/19/96 12:49 PM by AppMaker

#include "CProgressBars.h"

#include <UReanimator.h>
#include <URegistrar.h>
#include <LStream.h>
#include <LStdControl.h>
#include "CGadgetsData.h"
#include "CmdCodes.h"

#define PPob_ProgressBarsID	203
#define RidL_ProgressBarsID	203

Boolean		CProgressBars::sIsRegistered = false;

//----------
void
CProgressBars::RegisterClass ()
{
	URegistrar::RegisterClass ('Pros', (ClassCreatorFunc)CProgressBars::CreateProgressBarsStream);

	// register the pane classes we use

	sIsRegistered = true;
}

//----------
CProgressBars*
CProgressBars::CreateProgressBars(
	LCommander			*inSuperCommander,
	CGadgetsData		*inData)
{
	if (!sIsRegistered) {
		RegisterClass ();
	}

	CProgressBars		*window;

	window = (CProgressBars *)LWindow::CreateWindow(PPob_ProgressBarsID, inSuperCommander);
	window->ConnectToData (inData);

	return window;
}

//----------
//	This is the function you register with URegistrar to create a
//	CProgressBars from a resource

CProgressBars*
CProgressBars::CreateProgressBarsStream(
	LStream	*inStream)
{
	return (new CProgressBars(inStream));
}

//----------
CProgressBars::CProgressBars()
{
}

//----------
CProgressBars::CProgressBars(
	LStream	*inStream)
		: LWindow(inStream)
{
}

//----------
CProgressBars::~CProgressBars()
{
}

//----------
//	This member function gets called once the containment hierarchy that contains
//	this pane has been built. It gives us a chance to get data members for
//	interesting subviews, and to do other operations now that our subviews exist.
void
CProgressBars::FinishCreateSelf()
{
	mRectBar = (LStdControl *)FindPaneByID ('Rect');
	mBarberBar = (LStdControl *)FindPaneByID ('Barr');
	mProgressBar = (LStdControl *)FindPaneByID ('Pros');

	UReanimator::LinkListenerToControls(this, this, RidL_ProgressBarsID);
		// the purpose is to "connect" self to whatever controls
		// that we want to "listen" to

// any additional initialization for your window:

}

//----------
void
CProgressBars::ConnectToData	(CGadgetsData		*inData)
{
	mData = inData;
	inData->AddListener (this);
}

//----------
void
CProgressBars::ListenToMessage(
	MessageT	inMessage,
	void		*ioParam)
{
	switch (inMessage) {

	default:
		break;
	}
}

//----------
Boolean
CProgressBars::ObeyCommand(
	CommandT	inCommand,
	void		*ioParam)
{
	Boolean		cmdHandled = true;

	switch (inCommand) {

	// +++ Add cases here for the commands you handle
	//		Remember to add same cases to FindCommandStatus below
	//		to enable/disable the commands

	default:
			cmdHandled = LWindow::ObeyCommand(inCommand, ioParam);
		break;
	}

	return cmdHandled;
}

//----------
void
CProgressBars::FindCommandStatus(
	CommandT	inCommand,
	Boolean		&outEnabled,
	Boolean		&outUsesMark,
	Char16		&outMark,
	Str255		outName)
{
	outUsesMark = false;

	switch (inCommand) {

	// +++ Add cases here for the commands you handle

	default:
			LWindow::FindCommandStatus(inCommand, outEnabled,
										outUsesMark, outMark, outName);
		break;
	}
}

//----------
Boolean
CProgressBars::FocusDraw()
{
	Boolean		focused = LView::FocusDraw();

	if (focused) {
		AuxWinHandle	awHndl;
		CTabHandle		awCTable;
		ColorSpec		contentSpec;

		GetAuxWin(GetMacPort(), &awHndl);
		awCTable = (**awHndl).awCTable;
		contentSpec = (**awCTable).ctTable [wContentColor];		// should search vs. index
		::RGBBackColor(&contentSpec.rgb);
	}

	return focused;
}
