// CListArticles.cp -- window methods
// Created 01/01/95 12:01 PM by AppMaker

#include "CListArticles.h"
#include "FileAndFind_OOFILE.h"

#include <UReanimator.h>
#include <LStream.h>
#include <LListBox.h>
#include <LStdControl.h>

#define PPob_ListArticlesID	200
#define RidL_ListArticlesID	200


//----------
//	This is the function you register with URegistrar to create a
//	CListArticles from a resource

CListArticles*
CListArticles::CreateListArticlesStream(
	LStream	*inStream)
{
	return (new CListArticles(inStream));
}

//----------
CListArticles::CListArticles()
{
}

//----------
CListArticles::CListArticles(
	LStream	*inStream)
		: LWindow(inStream)
{
}

//----------
CListArticles::~CListArticles()
{
}

//----------
//	This member function gets called once the containment hierarchy that contains
//	this pane has been built. It gives us a chance to get data members for
//	interesting subviews, and to do other operations now that our subviews exist.
void
CListArticles::FinishCreateSelf()
{
	mArticlesList = (LListBox *)FindPaneByID('Arts');
	mNewButton = (LStdButton *)FindPaneByID('New ');
	mEditButton = (LStdButton *)FindPaneByID('Edit');
	mDeleteButton = (LStdButton *)FindPaneByID('Dele');

	UReanimator::LinkListenerToControls(this, this, RidL_ListArticlesID);
		// the purpose is to "connect" self to whatever controls
		// that we want to "listen" to

mArticlesList->AddListener(this);  // LListBox can't be included in RidL
// any additional initialization for your window:

}


//----------
void
CListArticles::ListenToMessage(
	MessageT	inMessage,
	void		*ioParam)
{
	switch (inMessage) {
	default:
	if (!OOFILEhandlesMessage(inMessage, ioParam))
	  ; // do something
		break;
	}
}

//----------
Boolean
CListArticles::ObeyCommand(
	CommandT	inCommand,
	void		*ioParam)
{
	Boolean		cmdHandled = true;

	switch (inCommand) {

	// +++ Add cases here for the commands you handle
	//		Remember to add same cases to FindCommandStatus below
	//		to enable/disable the commands

	default:
	cmdHandled = OOFILEhandlesMessage(inCommand, ioParam);
	if (!cmdHandled)
			cmdHandled = LWindow::ObeyCommand(inCommand, ioParam);
		break;
	}

	return cmdHandled;
}

//----------
void
CListArticles::FindCommandStatus(
	CommandT	inCommand,
	Boolean		&outEnabled,
	Boolean		&outUsesMark,
	Char16		&outMark,
	Str255		outName)
{
	outUsesMark = false;

	switch (inCommand) {

	// +++ Add cases here for the commands you handle

	default:
			LWindow::FindCommandStatus(inCommand, outEnabled,
										outUsesMark, outMark, outName);
		break;
	}
}

//----------
Boolean
CListArticles::FocusDraw()
{
	Boolean		focused = LView::FocusDraw();

	if (focused) {
		AuxWinHandle	awHndl;
		CTabHandle		awCTable;
		ColorSpec		contentSpec;

		GetAuxWin(GetMacPort(), &awHndl);
		awCTable = (**awHndl).awCTable;
		contentSpec = (**awCTable).ctTable [wContentColor];		// should search vs. index
		::RGBBackColor(&contentSpec.rgb);
	}

	return focused;
}


void CListArticles::SetDatabase(CdbArticles* inArticles)
{
// our copy of the database, if we need to change its state in our Do methods
mArticles = inArticles;	

// link view to controls created in FinishCreateSelf
dbView* theView = new dbView(inArticles);
*theView  << inArticles->Title ;
AdoptView(theView);
BrowseViewWithListBox(mArticlesList);  
inArticles->sortBy(inArticles->Title());
}


// lightweight class to wrap creating CListArticles

LWindow* CListArticlesFactory::makeWindow(const bool loadData) const
{
CdbArticles* realTable = (CdbArticles*) mTable;  // safe downcast
   // would later use dynamic_cast to test the above
CListArticles *win = (CListArticles *)LWindow::CreateWindow(PPob_ListArticlesID, mCommander);
win->SetDatabase(realTable);
if (loadData)
	win->LoadBrowseData();
return (LWindow*) win;
}

