/* Dispatcher.c -- dispatcher for windows and for modeless dialogs */
/* Created 01/01/95 12:01 PM by AppMaker */

#include <Types.h>
#include <Quickdraw.h>
#include <Controls.h>
#include <Dialogs.h>
#include <Events.h>
#include <Lists.h>
#include <Menus.h>
#include <TextEdit.h>
#include "Buttons.h"
#include "TabbedPanel.h"
#include "Sliders.h"
#include "ProgressBars.h"
#include "Pallette.h"
#include "Globals.h"
#include "Dispatcher.h"

/*----------*/
void DoIdle (void)
{
} /*DoIdle*/

/*----------*/
void OpenWindows	(FSSpec*		fileSpec,
					 short			fRefNum)
{

	OpenButtons (fileSpec, fRefNum);
	OpenTabbedPanel (fileSpec, fRefNum);
	OpenSliders (fileSpec, fRefNum);
	OpenProgressBars (fileSpec, fRefNum);
	OpenPallette (fileSpec, fRefNum);

} /*OpenWindows*/

/*----------*/
void CloseCurWindow (void)
{
	switch (cur->windowKind) {
		case WButtons:
				CloseButtons ();
			break;
		case WTabbedPanel:
				CloseTabbedPanel ();
			break;
		case WSliders:
				CloseSliders ();
			break;
		case WProgressBars:
				CloseProgressBars ();
			break;
		case WPallette:
				ClosePallette ();
			break;

	} /*switch*/
} /*CloseCurWindow*/

/*----------*/
void DoControl		(ControlHandle	whichControl,
					 short			whichPart,
					 Point			where)
{
	switch (cur->windowKind) {
		case WButtons:
				ControlButtons (whichControl, whichPart, where);
			break;
		case WTabbedPanel:
				ControlTabbedPanel (whichControl, whichPart, where);
			break;
		case WSliders:
				ControlSliders (whichControl, whichPart, where);
			break;
		case WProgressBars:
				ControlProgressBars (whichControl, whichPart, where);
			break;
		case WPallette:
				ControlPallette (whichControl, whichPart, where);
			break;

	} /*switch*/
} /*DoControl*/

/*----------*/
void MouseInContent	(Point		where,
					 short		modifiers)
{
	switch (cur->windowKind) {
		case WButtons:
				MouseInButtons (where, modifiers);
			break;
		case WTabbedPanel:
				MouseInTabbedPanel (where, modifiers);
			break;
		case WSliders:
				MouseInSliders (where, modifiers);
			break;
		case WProgressBars:
				MouseInProgressBars (where, modifiers);
			break;
		case WPallette:
				MouseInPallette (where, modifiers);
			break;

	} /*switch*/
} /*MouseInContent*/

/*----------*/
void TypeInWindow	(char	ch)
{
	switch (cur->windowKind) {
		case WButtons:
				TypeInButtons (ch);
			break;
		case WTabbedPanel:
				TypeInTabbedPanel (ch);
			break;
		case WSliders:
				TypeInSliders (ch);
			break;
		case WProgressBars:
				TypeInProgressBars (ch);
			break;
		case WPallette:
				TypeInPallette (ch);
			break;

	} /*switch*/
} /*TypeInWindow*/

/*----------*/
void UpdateContent (void)
{
	switch (cur->windowKind) {
		case WButtons:
				UpdateButtons ();
			break;
		case WTabbedPanel:
				UpdateTabbedPanel ();
			break;
		case WSliders:
				UpdateSliders ();
			break;
		case WProgressBars:
				UpdateProgressBars ();
			break;
		case WPallette:
				UpdatePallette ();
			break;

	} /*switch*/
} /*UpdateContent*/

/*----------*/
void ActivateContent (Boolean	activate)
{
	switch (cur->windowKind) {
		case WButtons:
				ActivateButtons (activate);
			break;
		case WTabbedPanel:
				ActivateTabbedPanel (activate);
			break;
		case WSliders:
				ActivateSliders (activate);
			break;
		case WProgressBars:
				ActivateProgressBars (activate);
			break;
		case WPallette:
				ActivatePallette (activate);
			break;

	} /*switch*/
} /*ActivateContent*/

/*----------*/
void ResizeContent (void)
{
	switch (cur->windowKind) {
		case WButtons:
				ResizeButtons ();
			break;
		case WTabbedPanel:
				ResizeTabbedPanel ();
			break;
		case WSliders:
				ResizeSliders ();
			break;
		case WProgressBars:
				ResizeProgressBars ();
			break;
		case WPallette:
				ResizePallette ();
			break;

	} /*switch*/
} /*ResizeContent*/

/*----------*/
pascal void ScrollWindow	(short		newValue,
							 short		oldValue)
{
	switch (cur->windowKind) {
		case WButtons:
				ScrollButtons (newValue, oldValue);
			break;
		case WTabbedPanel:
				ScrollTabbedPanel (newValue, oldValue);
			break;
		case WSliders:
				ScrollSliders (newValue, oldValue);
			break;
		case WProgressBars:
				ScrollProgressBars (newValue, oldValue);
			break;
		case WPallette:
				ScrollPallette (newValue, oldValue);
			break;

	} /*switch*/
} /*ScrollWindow*/

/*----------*/
void InitModelessDialogs (void)
{

} /*InitModelessDialogs*/

/*----------*/
void CloseModelessDialog (DialogPtr		whichDialog)
{

} /*CloseModelessDialog*/

/*----------*/
Boolean FilterModeless	(DialogPtr		whichDialog,
						 EventRecord	*event,
						 short			*itemHit)
{

	return (false);
} /*FilterModeless*/

/*----------*/
void DoModelessItem		(DialogPtr		whichDialog,
						 short			itemNr)
{

} /*DoModelessItem*/

/* Dispatcher */
