/* Sliders.c */
/* Created 01/01/95 12:01 PM by AppMaker */

#include <Types.h>
#include <Quickdraw.h>
#include <Controls.h>
#include <Dialogs.h>
#include <Events.h>
#include <Lists.h>
#include <Menus.h>
#include <Resources.h>
#include <TextEdit.h>
#include <ToolUtils.h>
#include "ResourceDefs.h"
#include "Globals.h"
#include "Miscellany.h"
#include "Scrolling.h"
#include "WindowAids.h"
#include "GadgetsData.h"
#include "Sliders.h"

#define VerticalScroll		1
#define SliderScroll		2
#define SpinnerScroll		3
#define HorizontalScroll		4
#define PictSliderScroll		5


/*----------*/
void OpenSliders	(FSSpec*	fileSpec,
						 short		fRefNum)
{
	WindowPtr		newWindow;
	Rect			bounds;

	newWindow = GetWindow (WIND_Sliders);
	if (fileSpec->name [0] != 0) {
		SetWTitle (newWindow, fileSpec->name);
	}
	SetPort (newWindow);
	SetNewInfo (newWindow);
	cur->vScroll = nil;
	cur->hScroll = nil;
	cur->fileNum	= fRefNum;
	cur->dirty		= false;
	cur->filename	= NewString (fileSpec->name);
	cur->windowKind = WSliders;
	((WindowPeek) curWindow)->windowKind = userKind + WSliders;
	cur->witlHandle = GetResource ('Witl', WIND_Sliders);
	cur->wictHandle = GetResource ('Wict', WIND_Sliders);

		cur->VerticalHandle = GetNewControl (CNTL_Vertical, newWindow);
		cur->SliderHandle = GetNewControl (CNTL_Slider, newWindow);
		cur->SpinnerHandle = GetNewControl (CNTL_Spinner, newWindow);
		cur->HorizontalHandle = GetNewControl (CNTL_Horizontal, newWindow);
		cur->PictSliderHandle = GetNewControl (CNTL_PictSlider, newWindow);
	cur->text = nil;


	} /*OpenSliders*/

	/*----------*/
	void CloseSliders	(void)
	{

	DisposHandle ((Handle) cur->filename);
	DiscardInfo (curWindow);
} /*CloseSliders*/

/*----------*/
void ControlSliders  (ControlHandle		whichControl,
						 short				whichPart,
						 Point				where)
{
	Rect			bounds;

	if (whichControl == cur->VerticalHandle) {
		TrackScroll (cur->VerticalHandle, whichPart, where, nil);
	}
	if (whichControl == cur->SliderHandle) {
		TrackScroll (cur->SliderHandle, whichPart, where, nil);
	}
	if (whichControl == cur->SpinnerHandle) {
		TrackScroll (cur->SpinnerHandle, whichPart, where, nil);
	}
	if (whichControl == cur->HorizontalHandle) {
		TrackScroll (cur->HorizontalHandle, whichPart, where, nil);
	}
	if (whichControl == cur->PictSliderHandle) {
		TrackScroll (cur->PictSliderHandle, whichPart, where, nil);
	}

} /*ControlSliders*/

/*----------*/
void MouseInSliders	(Point		where,
						 short		modifiers)
{
	Rect			bounds;


} /*MouseInSliders*/

/*----------*/
void TypeInSliders   (char		ch)
{
	if (cur->text == nil) {
		SysBeep (1);
	} else {
		TEKey (ch, cur->text);
		cur->dirty = true;
	}
} /*TypeInSliders*/

/*----------*/
void UpdateSliders (void)
{
	Rect			bounds;

	SetWFont (VerticalScroll);
	Draw1Control (cur->VerticalHandle);
	SetWFont (SliderScroll);
	Draw1Control (cur->SliderHandle);
	SetWFont (SpinnerScroll);
	Draw1Control (cur->SpinnerHandle);
	SetWFont (HorizontalScroll);
	Draw1Control (cur->HorizontalHandle);
	SetWFont (PictSliderScroll);
	Draw1Control (cur->PictSliderHandle);
	DrawClippedGrow (-15, -15);
} /*UpdateSliders*/

/*----------*/
void ActivateSliders	(Boolean	activate)
{
	EnableControl (cur->VerticalHandle, activate);
	EnableControl (cur->SliderHandle, activate);
	EnableControl (cur->SpinnerHandle, activate);
	EnableControl (cur->HorizontalHandle, activate);
	EnableControl (cur->PictSliderHandle, activate);

	DrawClippedGrow (-15, -15);
} /*ActivateSliders*/

/*----------*/
void ResizeSliders	(void)
{
	/* application-specific code to resize items in window */
} /*ResizeSliders*/

/*----------*/
pascal void ScrollSliders	(short		newValue,
								 short		oldValue)
{
	/* application-specific code to scroll window */
} /*ScrollSliders*/

/* Sliders */
